# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml
image: "node:latest"

stages:          # List of stages for jobs, and their order of execution
  - build
  - test
  - QA
  - UAT

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - echo "Compiling the code..."
    - echo "Compile complete."
     - "curl -X POST --fail -F token=glptt-d8a66be8ff772c18cfc413a5bdc0c201835dbb91 -F ref=REF_NAME https://gitlab.com/api/v4/projects/39026419/trigger/pipeline"
Validation-to-QA:
  stage: QA
  needs: ["build-job"]
  only:
    variables:
      - $CI_COMMIT_REF_NAME == 'master'
  except:
    variables:
      - $SANDBOX_DISABLED
      - $SALESFORCE_DEPLOYMENT_APPROACH != 'PACKAGING' && $SALESFORCE_DEPLOYMENT_APPROACH 
  when: on_success
  allow_failure: false
  environment:
    name: sandbox
    url: https://login.salesforce.com
  script:
    - npm install sfdx-cli --global
    - sfdx plugins:install sfpowerkit
    - sfdx sfpowerkit:auth:login -u $username -p $Password -s $Token -a $orgAlias -r $LoginUrl
    - sfdx force:source:deploy -u $orgAlias -p force-app -c
Validation-to-UAT:
  stage: UAT
  only:
    variables:
      - $CI_COMMIT_REF_NAME == 'master'
  except:
    variables:
      - $SANDBOX_DISABLED
      - $SALESFORCE_DEPLOYMENT_APPROACH != 'PACKAGING' && $SALESFORCE_DEPLOYMENT_APPROACH 
  when: manual
  allow_failure: false
  environment:
    name: sandbox
    url: https://login.salesforce.com
  script:
    - npm install sfdx-cli --global
    - sfdx plugins:install sfpowerkit
    - sfdx sfpowerkit:auth:login -u $username -p $Password -s $Token -a $orgAlias -r $LoginUrl
    - sfdx force:source:deploy -u $orgAlias -p force-app -c

